<template>
  <div class="container">
    <p>{{ taskInfo }}</p>
    <p>{{ $route.params }}</p>
    <Person
        v-for="(user, role) in filteredTaskMakers"
        :key="role"
        :link="user.gitLink"
        :name="user.name"
        :role="role"
    />
    <div v-if="filteredStates" class="buttons-container">
      <button
          @click.stop="moveTask(status)"
          v-for="(status, index) in filteredStates"
          :key="index"
      >
        {{ status }}
      </button>
    </div>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";

export default {
  name: "TaskModal",
  data() {
    return {
      states: ["In work", "Review", "Test", "Done"],
    };
  },
  watch: {
    async $route(to) {
      if (to.params.id) {
        await this.getTaskMakers(to.params.board_id + "/" + to.params.id);
      }
    },
  },
  components: {
    Person: () => import("@/components/Person"),
  },
  methods: {
    ...mapActions(["getTaskMakers", "changeTaskStatus"]),
    moveTask(status) {
      this.changeTaskStatus({status: status, path: this.currentRoute});
      this.$emit("close-modal");
    },
  },
  computed: {
    ...mapGetters({taskMakers: "getTaskMakers", taskInfo: "getTaskInfo"}),
    filteredStates() {
      if (this.taskInfo.task) {
        return this.states.filter((x) => x !== this.taskInfo.task.status);
      }
      return [];
    },
    currentRoute() {
      return this.$route.params.board_id + "/" + this.$route.params.id;
    },
    filteredTaskMakers() {
      const taskMakers = {};
      for (let i in this.taskMakers) {
        if (!this.taskMakers[i]) {
          taskMakers[i] = "unassigned";
        } else {
          taskMakers[i] = this.taskMakers[i];
        }
      }
      return taskMakers;
    },
  },

  async mounted() {
    if (this.$route.params.id) {
      await this.getTaskMakers(
          this.$route.params.board_id + "/" + this.$route.params.id
      );
    }
  },
};
</script>

<style scoped>
.container {
  width: 600px;
  height: min-content;
  border: 1px solid black;
  border-radius: 25px;
  background-color: white;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.5);
  padding: 10px;
}

.buttons-container {
  display: flex;
  justify-content: space-around;
  width: 100%;
}
</style>
